/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2018, Natural Language Processing Lab, Northestern University.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Created by: XIAO Tong (xiaotong@mail.neu.edu.cn) 2018-07-05
 */

#ifndef __XNAME_H__
#define __XNAME_H__

namespace nts { // namespace nts(NiuTrans.Tensor)
    
#define MATH_ARITHMETIC     0x00001000
#define MATH_SUM            MATH_ARITHMETIC + 1
#define MATH_MULTIPLY       MATH_SUM + 1
    
/* get operator name */
const char * GetOPName(int type)
{
    if((type & MATH_ARITHMETIC) != 0){
        if(type == MATH_SUM)
            return "M_SUM";
        else if(type == MATH_MULTIPLY)
            return "M_MULTIPLY";
    }
    
    return "NULL";
}
    
} // namespace nts(NiuTrans.Tensor)

#endif // __XNAME_H__
